// modlib.cpp : Definiert den Einsprungpunkt fr die DLL-Anwendung.
//

#ifdef MODLIB_EXPORTS
#define MODLIB_API __declspec(dllexport)
#else
#define MODLIB_API __declspec(dllimport)
#endif

#define WIN32_LEAN_AND_MEAN		// Selten benutzte Teile der Windows-Header nicht einbinden
#include <windows.h>

extern "C" {
  int    __cdecl dumb_atexit(void * proc);
  void   __cdecl dumb_exit(void);
  void   __cdecl dumb_register_stdfiles(void);
  void * __cdecl load_duh(const char *filename);
  void * __cdecl dumb_load_it(const char *filename);
  void * __cdecl dumb_load_xm(const char *filename);
  void * __cdecl dumb_load_s3m(const char *filename);
  void * __cdecl dumb_load_mod(const char *filename);
  void * __cdecl duh_start_sigrenderer(void *duh, int sig, int n_channels, int pos);
  void   __cdecl duh_end_sigrenderer(void *sigrenderer);
  void   __cdecl unload_duh(void *duh);
  int    __cdecl dumb_it_callback_terminate(void *data);  

  long   __cdecl duh_render(void *sigrenderer,int bits, int unsign,float volume, float delta, long size, void *sptr);
  long   __cdecl duh_get_length(void *duh);
  int    __cdecl duh_sigrenderer_get_n_channels(void *sigrenderer);
  long   __cdecl duh_sigrenderer_get_position(void *sigrenderer);
  void * __cdecl duh_get_it_sigrenderer(void *sigrenderer);
  void   __cdecl dumb_it_set_loop_callback         (void *sigrenderer, void * callback, void *data);
  void   __cdecl dumb_it_set_xm_speed_zero_callback(void *sigrenderer, void * callback, void *data);
}


BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  dwReason, 
                       LPVOID lpReserved
					 )
{
	// Perform actions based on the reason for calling.
    switch( dwReason ) 
    { 
        case DLL_PROCESS_ATTACH:
         // Initialize once for each new process.
         // Return FALSE to fail DLL load.
			dumb_atexit(&dumb_exit);
			dumb_register_stdfiles();
            break;

        case DLL_THREAD_ATTACH:
         // Do thread-specific initialization.
            break;

        case DLL_THREAD_DETACH:
         // Do thread-specific cleanup.
            break;

        case DLL_PROCESS_DETACH:
         // Perform any necessary cleanup.
            break;
    }

    return TRUE;
}

#ifdef __cplusplus
	extern "C" {
#endif


#if 0
MODLIB_API void __stdcall RegisterStdFiles(void) {
  dumb_register_stdfiles();
}
#endif

MODLIB_API void * __stdcall OpenMod(const char *filename) {
  void * duh=NULL;

  duh = load_duh(filename);
  if (!duh) duh = dumb_load_it(filename);
  if (!duh) duh = dumb_load_xm(filename);
  if (!duh) duh = dumb_load_s3m(filename);
  if (!duh) duh = dumb_load_mod(filename);
  return duh;
}

#if 1
MODLIB_API long __stdcall GetLength(void *lpFile) {
  return duh_get_length(lpFile);
}
#endif

MODLIB_API void __stdcall CloseMod(void * lpFile) {
  unload_duh(lpFile);
}

#if 1
MODLIB_API int __stdcall GetChannels(void *lpMod) {
  return duh_sigrenderer_get_n_channels(lpMod);
}
MODLIB_API long __stdcall GetPosition(void *lpMod) {
  return duh_sigrenderer_get_position(lpMod);
}
#endif

MODLIB_API void * __stdcall StartMod(void * lpFile,int n_channels) {
  void * lpMod=duh_start_sigrenderer(lpFile,0, n_channels,0);
  if (lpMod!=NULL) {
    void * lpIt =duh_get_it_sigrenderer(lpMod);
    if (lpIt!=NULL) {
      dumb_it_set_loop_callback         (lpIt,&dumb_it_callback_terminate,NULL);
      dumb_it_set_xm_speed_zero_callback(lpIt,&dumb_it_callback_terminate,NULL);
    }
  }
  return lpMod;
}
MODLIB_API long __stdcall GetSamples(void *lpMod, 
									 int   bits, 
									 int   unsign, 
									 float volume, 
									 float delta, 
									 long  size, 
									 void *sptr) {
  return duh_render(lpMod,bits,unsign,volume,delta,size,sptr);
}
MODLIB_API void __stdcall StopMod(void * lpMod) {
  duh_end_sigrenderer(lpMod);
}

/*
enum snd_PLUGINTYPES {
  FILE_PLUGIN,
  DEVICE_PLUGIN
};

struct snd_PLUGIN {
  char * Name;
  long FSVersion;
  enum snd_PLUGINTYPES Type;
};

#define MakeVersion(maj,min,build) ((maj) << 16) || ((min) << 8) || (build)
MODLIB_API long __stdcall ISANY(struct snd_PLUGIN * plug) {
  plug->Name      = "dumb 0.9.3 [D]ynamic [U]niversal [M]usic [B]ibliotheque";
  plug->FSVersion = MakeVersion(0,0,3);
  plug->Type      = FILE_PLUGIN;
  return 1;
}
*/

#ifdef __cplusplus
	}
#endif

